<?php

namespace Procour\Client;
use Procour\Client\Requests;

class Client
{
    protected $key = null;
    protected $number = null;
    protected $cost = 0;
    protected $type = null;
    protected $sms = 0;

    protected $available_types = [
        // "procour_self",
        "procour_post_rf",
        "procour_courier"
    ];
    
    protected $calc_url = 'https://lk.pro-cour.ru/calculator.php';
    protected $xml_url = 'https://lk.pro-cour.ru/xml/';

    public function __construct()
    {        
    }

    public function setKey($key)
    {
        $this->key = $key;        
    }

    public function setNumber($number)
    {
        $this->number = $number;
    }

    public function setDeliveryCost($cost)
    {
        $this->cost = $cost;
    }

    public function setType($type)
    {
        if(!in_array($type, $this->available_types))
            throw new \Exception("Не допустимый тип доставки (".$type.")", 1);
            
        $this->type = $type;
    }

    public function setSMS($sms)
    {
        $this->sms = $sms;
    }

    public function getApiUrl()
    {
        return $this->xml_url;
    }

    protected function getSession()
    {
        $newsXML = new \SimpleXMLElement("<?xml version=\"1.0\" encoding=\"UTF-8\"?><methodCall/>");
        $newsXML->addChild('methodName','auth');
        $params = $newsXML->addChild('params');
        $params->addChild('uid',$this->key);        

        $xml = Request::post($this->xml_url,$newsXML->asXML());
        {
            return $xml->params->session;            
        }       
    }

    protected function foundCity()
    {
        return 0;
    }

    public static function getDeliveryCosts($info)
    {
    // TODO                
    }
	
    public function createOrder($info)
    {                
        $newsXML = new \SimpleXMLElement("<?xml version=\"1.0\" encoding=\"UTF-8\"?><methodCall/>");
        $newsXML->addChild('methodName','request');
        $newsXML->addChild('session',$this->getSession());
        $params = $newsXML->addChild('params');
        $delivery = $params->addChild('delivery');
        $item = $delivery->addChild('item');

        $item->addChild('date',strftime("%d.%m.%Y",time() + 24*60*60));
        $item->addChild('fio',$info['location']['firstname'].' '.$info['location']['lastname']);
        
        if(isset($info['location']['phone'])){
            $item->addChild('phone',$info['location']['phone']);
            $item->addChild('sms',$this->sms);
        }
        else            
            $item->addChild('phone');

        $item->addChild('city',$this->foundCity());

        if($this->type == "procour_self"){
            $item->addChild('address','самовывоз');
            $item->addChild('point','point_id');
        }
        elseif($this->type == "procour_post_rf")
            $item->addChild('post',1);         
        else
            $item->addChild('address',$info['location']['zipcode'].', '.$info['location']['state_descr'].( ($info['location']['state_descr'] != $info['location']['city']) ? ', '.$info['location']['city']:"").', '.$info['location']['address']);
        
        $item->addChild('postindex',$info['location']['zipcode']);
        $item->addChild('number',$this->number);
        $item->addChild('summa',$info['C'] + $this->cost);
        $item->addChild('weight',$info['W']);
        $item->addChild('places',$info['I']);
        $item->addChild('partial',0);

        $xml = Request::post($this->xml_url,$newsXML->asXML());
        return (string)$xml->params->delivery->item;
    }
}