<?php

namespace Procour\Client;

class Request
{
    // cache lifetime 15 minutes
    static $lifetime = 15*60;
		
    static  function get_cache($key){
        $file = $key . '.cache';
        $cache_file =  $_SERVER['DOCUMENT_ROOT'].'/var/cache/procour/' . $file;
        if (empty(self::$lifetime)){
            return false;
        }
                
        if (is_file($cache_file) && (filemtime($cache_file) >= (time() - (self::$lifetime)))){
            return @file_get_contents($cache_file);
        }
        return false;
    }
    
    static  function set_cache($key, $cnt){
		$file = $key . '.cache';
        $cache_file =  $_SERVER['DOCUMENT_ROOT'].'/var/cache/procour/' . $file;
        return file_put_contents($cache_file, $cnt);
    }

    static function get($api_url, $args)
    {
        return self::send('GET', $api_url, $args);
    }

    static function post($api_url, $args)
    {
        return self::send('POST', $api_url, $args);
    }

    static private function send($method, $api_url, $args)
    {
        $hashRequest =  md5($api_url . $args);
		if ($out = self::get_cache($hashRequest)){             
            return @simplexml_load_string($out);
        }
        else 
        {
            if ($curl = curl_init()) {
                if ($method == 'GET') {
                    curl_setopt($curl, CURLOPT_URL, $api_url . (is_array($args) && !empty($args) ? '?' . http_build_query($args) : ''));
                } elseif ($method == 'POST') {
                    curl_setopt($curl, CURLOPT_URL, $api_url);
                    curl_setopt($curl, CURLOPT_POST, true);
                    curl_setopt($curl, CURLOPT_POSTFIELDS, $args);
                }
                curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

                $errno = curl_errno($curl);
                $error = curl_error($curl);
                $out = curl_exec($curl);
                curl_close($curl);

                if ($errno)
                    throw new \Exception("Ошибка связи с сервером", 1);

                $xml = @simplexml_load_string($out);
                if($xml->params->status != 'Ok')
                    throw new \Exception($xml->params->statusMsg, 1);
            } else {
                throw new \Exception("Ошибка инициализации", 1);
            }
            self::set_cache($hashRequest,$out);
            return @simplexml_load_string($out);
        }		
    }
}